/* Sistemas Integrados TEKNISA

Nome: 7822_PLASTPs - EXPORTA_EXC_CONSUMO.SQL

Descrio:
Procedimento para exportao de exceo no consumo das filial agregadas do Sistema PME

Criao:
28/04/2007 - Felipe Amaral Gurgel
*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
           O.NAME = 'EXPORTA_EXC_CONSUMO' AND
	   TYPE = 'P' 		      AND
	   U.UID = O.UID              AND
	   U.NAME = USER)

   DROP PROCEDURE EXPORTA_EXC_CONSUMO
GO

CREATE PROCEDURE EXPORTA_EXC_CONSUMO
   @P_NRLISTAFILISERV     VARCHAR(10),
   @P_DTCONSSERVINIGRAVA  DATETIME,
   @P_DTCONSSERVFINGRAVA  DATETIME,
   @P_CDFILIORIG          VARCHAR(4),
   @P_CDSERVORIG          VARCHAR(5),
   @P_IDQTDECONS          VARCHAR(1),
   @P_IDTIPOCONS          VARCHAR(7),
   @P_DTCONSSERVORIG      DATETIME,
   @P_CDPRODUTO           VARCHAR(10),
   @P_IDSOBREPOR          VARCHAR(1),
   @P_CDFILICENTGRAVA     VARCHAR(4),
   @P_CDFILICENTORIG      VARCHAR(4),
   @P_CDFILCENTPME        VARCHAR(4),
   @P_NRLISTAPROD         VARCHAR(10)
AS
   DECLARE @V_DTGRAVA     DATETIME; 
   DECLARE @V_DIASEMANA   VARCHAR(1);
   DECLARE @V_SEMANAGRAVA VARCHAR(7); 
   DECLARE @V_IDTPCONSPME VARCHAR(1);
BEGIN

   SET @V_DTGRAVA = @P_DTCONSSERVINIGRAVA;
   SET @V_SEMANAGRAVA = @P_IDTIPOCONS;
   WHILE @V_DTGRAVA <= @P_DTCONSSERVFINGRAVA BEGIN
      SELECT @V_DIASEMANA = DATEPART(DW,@V_DTGRAVA);    --GRAVA O NMERO DO DIA DA SEMANA
      SELECT @V_SEMANAGRAVA = CHARINDEX (@V_DIASEMANA, @P_IDTIPOCONS);   --CONFERE O DIA DA SEMANA MARCADO PARA GRAVAR

      IF @V_SEMANAGRAVA = @V_DIASEMANA BEGIN
         IF @P_IDSOBREPOR = 'S' BEGIN
            DELETE
              FROM CONSSERVPME
             WHERE CDFILCENTPME = @P_CDFILCENTPME 
               AND CDFILIAL+CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = @P_NRLISTAFILISERV)
               AND IDQTDECONPME = @P_IDQTDECONS 
               AND IDTIPOCONPME = '9' 
               AND DTCONSERVPME = @V_DTGRAVA
               AND CDFILCENTPME+CDFILIAL+CDSERVFILI+CONVERT(VARCHAR, DTCONSERVPME, 103) NOT IN (SELECT DISTINCT CDFILCENTPME+LISTA.CDLISTA+CONVERT(VARCHAR, DTCONSERVPME, 103)
                                                                           FROM CONSSERVPME, LISTA
                                                                          WHERE CDFILCENTPME = @P_CDFILICENTORIG
                                                                            AND CDFILIAL = SUBSTRING(LISTA.CDLISTA, 1,4)
                                                                            AND CDSERVFILI = SUBSTRING(LISTA.CDLISTA, 5, 9)
                                                                            AND @P_CDFILIORIG+@P_CDSERVORIG = LISTA.CDLISTA
                                                                            AND IDQTDECONPME = @P_IDQTDECONS        
                                                                            AND IDTIPOCONPME = '9'
                                                                            AND DTCONSERVPME = @P_DTCONSSERVORIG
                                                                            AND LISTA.NRLISTA = @P_NRLISTAFILISERV);
         END
         DECLARE C_DIASEMCONSUMO CURSOR FOR
            (SELECT DISTINCT DIASEMCONSPME.IDTPCONSPME
               FROM DIASEMCONSPME, LISTA
              WHERE CDFILCENTPME = @P_CDFILCENTPME
                AND CDFILIAL = SUBSTRING(LISTA.CDLISTA, 1, 4)
                AND CDSERVFILI = SUBSTRING(LISTA.CDLISTA, 5, 9)
     	        AND CDFILIAL+CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = @P_NRLISTAFILISERV)     
                AND DTSEMCONSPME = @V_DTGRAVA);
         OPEN C_DIASEMCONSUMO;
         FETCH NEXT FROM C_DIASEMCONSUMO INTO @V_IDTPCONSPME;
         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            IF @V_IDTPCONSPME = 'A' BEGIN
               IF @P_IDQTDECONS = 'F' BEGIN     -- UPDATA DIASEMCONSPME PARA 'P'
                  UPDATE DIASEMCONSPME         
                     SET IDTPCONSPME = 'P'    
                   WHERE CDFILCENTPME = @P_CDFILICENTGRAVA 
                     AND CDFILIAL+CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = @P_NRLISTAFILISERV)
                     AND DTSEMCONSPME = @V_DTGRAVA
                     AND IDTPCONSPME = 'A';
               END
               ELSE BEGIN                          -- UPDATA DIASEMCONS PARA 'F'
                  UPDATE DIASEMCONSPME         
                     SET IDTPCONSPME = 'F'    
                   WHERE CDFILCENTPME = @P_CDFILICENTGRAVA 
                     AND CDFILIAL+CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = @P_NRLISTAFILISERV)
                     AND DTSEMCONSPME = @V_DTGRAVA
                     AND IDTPCONSPME = 'A';
               END        
            END;
            IF @V_IDTPCONSPME = @P_IDQTDECONS BEGIN     -- DELETA DIASEMCONS = P_IDQTDECONS
              DELETE 
                 FROM DIASEMCONSPME
                WHERE CDFILCENTPME = @P_CDFILICENTGRAVA
                  AND CDFILIAL+CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = @P_NRLISTAFILISERV)  
                  AND DTSEMCONSPME = @V_DTGRAVA;              
            END; 
	    FETCH NEXT FROM C_DIASEMCONSUMO INTO @V_IDTPCONSPME; 
         END;
         CLOSE C_DIASEMCONSUMO;
         DEALLOCATE C_DIASEMCONSUMO;                                  
         INSERT INTO CONSSERVPME
                (CDFILCENTPME, CDFILIAL, CDSERVFILI, IDQTDECONPME,
                 IDTIPOCONPME, DTCONSERVPME, CDPRODUTO, QTCONSERVPME)
                (SELECT @P_CDFILICENTGRAVA, SUBSTRING(LF.CDLISTA, 1, 4), SUBSTRING(LF.CDLISTA, 5, 9),
                        A.IDQTDECONPME, A.IDTIPOCONPME, @V_DTGRAVA, A.CDPRODUTO, A.QTCONSERVPME
                   FROM CONSSERVPME A, LISTA LP, LISTA LF
                  WHERE (A.CDFILCENTPME = @P_CDFILICENTORIG)  
                    AND (A.CDFILIAL     = @P_CDFILIORIG)     
                    AND (A.CDSERVFILI   = @P_CDSERVORIG)     
                    AND (A.IDQTDECONPME = @P_IDQTDECONS)     
                    AND (A.IDTIPOCONPME = '9')     
                    AND (A.DTCONSERVPME = @P_DTCONSSERVORIG) 
                    AND (LF.NRLISTA     = @P_NRLISTAFILISERV)
                    AND (LP.NRLISTA     = @P_NRLISTAPROD)        
                    AND (LP.CDLISTA     = A.CDPRODUTO)       
                    AND (LF.CDLISTA+LP.CDLISTA NOT IN (SELECT DISTINCT CDFILIAL+CDSERVFILI+CDPRODUTO
                                                         FROM CONSSERVPME B, LISTA L
                                                        WHERE B.CDFILCENTPME = @P_CDFILICENTGRAVA 
                                                          AND B.CDFILIAL+B.CDSERVFILI 
                                                           IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = @P_NRLISTAFILISERV)
                                                          AND B.IDQTDECONPME = @P_IDQTDECONS      
                                                          AND B.IDTIPOCONPME = '9'      
                                                          AND B.DTCONSERVPME = @V_DTGRAVA
                                                          AND B.CDPRODUTO  = A.CDPRODUTO)));
      END; 
      SET @V_DTGRAVA = @V_DTGRAVA + 1;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EXPORTA_EXC_CONSUMO','5.03.007';
GO

